;----------------------------------------------------------------------------------
;	FILE:			ADCDRV_5ch.asm
;
;	Description:	Four Channel ADC Result register interface macro
;
;	Version: 		2.0
;
;   Target:  		F2802x / F2803x
;
;--------------------------------------------------------------------------------
;  Copyright Texas Instruments  2010
;--------------------------------------------------------------------------------
;  Revision History:
;--------------------------------------------------------------------------------
;  Date	  	| Description
;--------------------------------------------------------------------------------
;  11/15/10  | Release 2.0	(MB)
;--------------------------------------------------------------------------------
;=============================
ADCDRV_5ch_INIT	.macro m,n,p,q,s
;=============================
_ADCDRV_5ch_RltPtrA	.usect "ADCDRV_5ch_Section",2,1,1	; output terminal 1
_ADCDRV_5ch_RltPtrB	.usect "ADCDRV_5ch_Section",2,1,1	; output terminal 2
_ADCDRV_5ch_RltPtrC	.usect "ADCDRV_5ch_Section",2,1,1	; output terminal 3
_ADCDRV_5ch_RltPtrD	.usect "ADCDRV_5ch_Section",2,1,1	; output terminal 4
_ADCDRV_5ch_RltPtrE .usect "ADCDRV_5ch_Section",2,1,1   ; output terminal 5

; publish Terminal Pointers for access from the C environment
		.def 	_ADCDRV_5ch_RltPtrA
		.def	_ADCDRV_5ch_RltPtrB
		.def	_ADCDRV_5ch_RltPtrC
		.def	_ADCDRV_5ch_RltPtrD
		.def 	_ADCDRV_5ch_RltPtrE

		MOVL	XAR2, #ZeroNet						; "ZeroNet" is address to a location initialised to 0 
		MOVW	DP, #_ADCDRV_5ch_RltPtrA
		MOVL	@_ADCDRV_5ch_RltPtrA, XAR2			; zero output terminal pointer
		MOVL	@_ADCDRV_5ch_RltPtrB, XAR2			; zero output terminal pointer
		MOVL	@_ADCDRV_5ch_RltPtrC, XAR2			; zero output terminal pointer
		MOVL	@_ADCDRV_5ch_RltPtrD, XAR2			; zero output terminal pointer
		MOVL	@_ADCDRV_5ch_RltPtrE, XAR2			; zero output terminal pointer
		
		.endm
		

;--------------------------------------------------------------------------------
;=============================
ADCDRV_5ch		.macro	m,n,p,q,s
;=============================
	
		MOVW    DP, #_ADCDRV_5ch_RltPtrA			; Load Data Page
        MOVL    XAR0,@_ADCDRV_5ch_RltPtrA			; Load Rlt1 Data Page Pointer in XAR0
		MOVL    XAR1,@_ADCDRV_5ch_RltPtrB			; Load Rlt2 Data Page Pointer in XAR1
		
		MOVW 	DP, #_AdcResult                     ; load Data Page to read ADC results
        MOV     ACC, @_AdcResult.ADCRESULT:m:<<12		; read result
        SUB     ACC, #2048<<12							; ACC = ADCRESULT - 2048
		MOVL    *XAR0,ACC							; store result in output pointer location
		
        MOV    	ACC, @_AdcResult.ADCRESULT:n:<<12		; read result
        SUB    	ACC,#2048<<12							; ACC = ADCRESULT - 2048
		MOVL    *XAR1,ACC

		MOVW    DP, #_ADCDRV_5ch_RltPtrC			; Load Data Page
        MOVL    XAR0,@_ADCDRV_5ch_RltPtrC			; Load Rlt1 Data Page Pointer in XAR0
		MOVL    XAR1,@_ADCDRV_5ch_RltPtrD			; Load Rlt2 Data Page Pointer in XAR1
		MOVL    XAR2,@_ADCDRV_5ch_RltPtrE
			
		MOVW 	DP, #_AdcResult                     ; load Data Page to read ADC results
		MOV    	ACC, @_AdcResult.ADCRESULT:p:<<12		; read result
		MOVL    *XAR0,ACC							; store result in output pointer location		
		
		MOV    	ACC, @_AdcResult.ADCRESULT:q:<<12		; read result
		MOVL    *XAR1,ACC								; store result in output pointer location
		
        MOV    	ACC, @_AdcResult.ADCRESULT:s:<<12		; read result
		MOVL    *XAR2,ACC							; store result in output pointer location	
			
		.endm
; end of file

