//----------------------------------------------------------------------------------
//	FILE:			SolarHv_DCAC-CAP_Cnf.C
//
//	Description:	The CAP initialization 
//
//	Version: 		1.0
//
//  Target:  		TMS320F2803x(PiccoloB 
//
//----------------------------------------------------------------------------------//  
//Copyright Texas Instruments 2004-2009
//----------------------------------------------------------------------------------
//  Revision History:
//----------------------------------------------------------------------------------
//  Date	  | Description / Status
//----------------------------------------------------------------------------------
// 29 OCT 2010 - Vieri
//----------------------------------------------------------------------------------
#include "SolarHv_DCAC-Settings.h"
#include "PeripheralHeaderIncludes.h"

void 	InitECapture();
void 	InitECap1Gpio(void);

void InitECapture()
{
   InitECap1Gpio();
   ECap1Regs.ECEINT.all = 0x0000;             // Disable all capture interrupts
   ECap1Regs.ECCLR.all = 0xFFFF;              // Clear all CAP interrupt flags
   ECap1Regs.ECCTL1.bit.CAPLDEN = 0;          // Disable CAP1-CAP4 register loads
   ECap1Regs.ECCTL2.bit.TSCTRSTOP = 0;        // Make sure the counter is stopped
   
   // Configure peripheral registers
   ECap1Regs.ECCTL1.bit.PRESCALE = 0;				//BYPASS THE prescaler
   ECap1Regs.ECCTL2.bit.CAP_APWM = 0;		//capture mode
   ECap1Regs.ECCTL2.bit.CONT_ONESHT = 1; // Oneshot mode

   ECap1Regs.ECCTL1.bit.CAP1POL = 1;          // Falling edge
   ECap1Regs.ECCTL1.bit.CAP2POL = 1;          // Rising edge
   ECap1Regs.ECCTL1.bit.CAP3POL = 1;          // Falling edge
   ECap1Regs.ECCTL1.bit.CAP4POL = 1;          // Rising edge
   
   ECap1Regs.ECCTL1.bit.CTRRST1 = 0;          // Don't reset the counter
   ECap1Regs.ECCTL1.bit.CTRRST2 = 0;          // Don't reset the counter        
   ECap1Regs.ECCTL1.bit.CTRRST3 = 0;          // Don't reset the counter       
   ECap1Regs.ECCTL1.bit.CTRRST4 = 0;          // Don't reset the counter 
          
   ECap1Regs.ECCTL2.bit.SYNCI_EN = 0;         // Disable sync in
   ECap1Regs.ECCTL2.bit.SYNCO_SEL = 0;        // Pass through
   
   ECap1Regs.ECCTL1.bit.CAPLDEN = 1;          // Enable capture units
   ECap1Regs.ECCTL2.bit.STOP_WRAP = 1; 
   ECap1Regs.ECCTL2.bit.REARM = 1;
   
   ECap1Regs.ECEINT.bit.CEVT1 = 1;            // 4 events = interrupt
    

   ECap1Regs.ECCTL2.bit.TSCTRSTOP = 1;        // Start Counter

}

void InitECap1Gpio(void)
{
   EALLOW;
/* Enable internal pull-up for the selected pins */
// Pull-ups can be enabled or disabled by the user.
// This will enable the pullups for the specified pins.
// Comment out other unwanted lines.

 GpioCtrlRegs.GPAPUD.bit.GPIO5 = 0;      // Enable pull-up on GPIO5 (CAP1)
//   GpioCtrlRegs.GPAPUD.bit.GPIO19 = 0;     // Enable pull-up on GPIO19 (CAP1)
// GpioCtrlRegs.GPAPUD.bit.GPIO24 = 0;     // Enable pull-up on GPIO24 (CAP1)

// Inputs are synchronized to SYSCLKOUT by default.
// Comment out other unwanted lines.

 GpioCtrlRegs.GPAQSEL1.bit.GPIO5 = 0;    // Synch to SYSCLKOUT GPIO5 (CAP1)
//   GpioCtrlRegs.GPAQSEL2.bit.GPIO19 = 0;   // Synch to SYSCLKOUT GPIO19 (CAP1)
// GpioCtrlRegs.GPAQSEL2.bit.GPIO24 = 0;   // Synch to SYSCLKOUT GPIO24 (CAP1)
/* Configure eCAP-1 pins using GPIO regs*/
// This specifies which of the possible GPIO pins will be eCAP1 functional pins.
// Comment out other unwanted lines.

 GpioCtrlRegs.GPAMUX1.bit.GPIO5 = 3;     // Configure GPIO5 as CAP1
//   GpioCtrlRegs.GPAMUX2.bit.GPIO19 = 3;    // Configure GPIO19 as CAP1
// GpioCtrlRegs.GPAMUX2.bit.GPIO24 = 1;    // Configure GPIO24 as CAP1

    EDIS;
}
