#include "DSP28x_Project.h"     // Device Headerfile and Examples Include File
#define	PktSizeLin				2

// Prototype statements for functions found within this file.
interrupt void Lina_Level0_ISR(void);
void PackTxBuffersLin(void);
void UnpackRxBuffersLin(void);
void SetupLin(void);
void error(void);

// Global variables
Uint16 sdataALin;     // Send data for SCI-A
Uint16 rdataALin;     // Received data for SCI-A


Uint32 LinL0IntVect;  //Vector for L0 interrupts

Uint16 iLin;			  //Generic iterator

extern int16 Gui_wPanelVolt;
extern int16 Gui_wPanelCurrent;
extern int16 Gui_wBoostOutputVolt;
extern int16 Gui_wPanelOutputPower;
extern int16 Gui_wMPPT_Status;
extern int16 Gui_wSysMode;
extern int16 Gui_wLLCOutputVolt;
extern int16 Gui_wTurnOn;
extern int16 Gui_wTurnOff;
extern int16 Gui_wMPPT_OnOff;


void (*RcvTaskPointerLin)(void); 			// State pointer for Command Packet Receive
Uint16	CmdPacketLin[PktSizeLin];


void GetCmdEchoByteLin(void);
void SendIndexByteLin(void);
void GetIndexEchoByteLin(void);
void GetDataByteLin(void);
void EchoDataByteLin(void);
void SendDataByteLin(void);
void GetCompleteByteLin(void);
void ReadyForDataLin(void);


void Inquiry_Panel_Voltage(void);
void Inquiry_Panel_Current(void);
void Inquiry_Boost_Voltage(void);
void Inquiry_Panel_Output_Power(void);
void Inquiry_MPPT_Status(void);
void Send_Running_Mode(void);
void Send_LLC_Output_Voltage(void);
void Send_Turn_On_Command(void);
void Send_Turn_Off_Command(void);
void Send_Turn_On_MPPT_Command(void);
void Send_Turn_Off_MPPT_Command(void);

int16 wTestcnt;
extern int16 wSendTurnOnCmd;
extern int16 wSendTurnOffCmd;
extern int16 wNoSciRevIntCnt;



extern int16 Gui_DC_Board_Connect;
int16 wErrorCnt;

//extern FSuperFlag;
extern union FSysFlags{
	
	Uint16	word;
	
	struct {
		Uint16	FwTurnOn:1;
		Uint16	FwTurnOff:1;
		
		Uint16  FwWarning:1;
		Uint16  FwFault:1;
		
		Uint16  FwClearFaultFlag:1;
		Uint16  FwOpRlyStatus:1;
		Uint16  FwPwmStatus:1;
		
		Uint16  FwAutoStartOnEn:1;
		Uint16  FwTurnOnConditionOk:1;
		Uint16  FwAutoStart:1;
		
		Uint16   resv:6;
		}BIT;
}FSuperFlag;
//extern  union FSysFlags FSuperFlag;







//LIN Communication
//======== SM Entry Point =================
void SerialHostCommsLin()
{		
	(*RcvTaskPointerLin)();	// Call routine pointed to by state pointer
}
//=========================================


void GetCmdEchoByteLin(void)
{
	UnpackRxBuffersLin();
	if (CmdPacketLin[0] == rdataALin)
	{
		if(CmdPacketLin[0] <= 0x2)
		{
			RcvTaskPointerLin = &SendIndexByteLin;		// point to next state
			SendIndexByteLin();
		}
		else if(CmdPacketLin[0] > 0x2)
		{
			RcvTaskPointerLin = &GetCmdEchoByteLin;		// point to next state
			
			if(CmdPacketLin[0] == 0x3)	//Slave echo the turn on cmd
			{
				wSendTurnOnCmd = 0;
			}
			else if(CmdPacketLin[0] == 0x4)
			{
				wSendTurnOffCmd = 0;
				FSuperFlag.BIT.FwTurnOff = 1;
			}
			
			// clear Command Packet
			for (iLin=0; iLin<PktSizeLin; iLin++)
			{
				CmdPacketLin[iLin] = 0x0;
			}
			sdataALin = 0x0;
   			rdataALin = 0x0;
		}
		
		//Gui_DC_Board_Connect = 1;
		wErrorCnt = 0;
	}
	else
	{
		if(((wErrorCnt++) >= 4))
		{
			//Gui_DC_Board_Connect = 0;
		}
		error();		
	}
		
}


void SendIndexByteLin(void)
{
	sdataALin = CmdPacketLin[1];
	PackTxBuffersLin();
	RcvTaskPointerLin = &GetIndexEchoByteLin;		// point to next state
}


void GetIndexEchoByteLin(void)
{
	UnpackRxBuffersLin();
	if(CmdPacketLin[1] == rdataALin)
	{
		if(CmdPacketLin[0] == 0x1)
		{
			//RcvTaskPointer = &GetDataByte;		// point to next state
			RcvTaskPointerLin = &ReadyForDataLin;
			ReadyForDataLin();			
		}
		else if(CmdPacketLin[0] == 0x2)
		{
			RcvTaskPointerLin = &SendDataByteLin;		// point to next state
			SendDataByteLin();
		}
	}
	
	else
		error();
}

void ReadyForDataLin(void)
{
	sdataALin = CmdPacketLin[1];
	PackTxBuffersLin();
	RcvTaskPointerLin = &GetDataByteLin;		// point to next state
}


void GetDataByteLin(void)
{
	UnpackRxBuffersLin();
	switch(CmdPacketLin[1])
	{
		case 0: Gui_wPanelVolt = rdataALin;
				break;
		case 1: Gui_wPanelCurrent = rdataALin;
				break;
		case 2: Gui_wBoostOutputVolt = rdataALin;
				break;
		case 3: Gui_wPanelOutputPower = rdataALin;
				break;
		case 4: Gui_wMPPT_Status = rdataALin;
				break;
		default:
				break;
	}
	
	RcvTaskPointerLin = &EchoDataByteLin;		// point to next state
	EchoDataByteLin();
}


void EchoDataByteLin(void)
{
	sdataALin = 0x00ff;
	PackTxBuffersLin();
	// clear Command Packet
	for (iLin=0; iLin<PktSizeLin; iLin++)
	{
		CmdPacketLin[iLin] = 0x0;
	}
	
	rdataALin = 0x0;
	sdataALin = 0x0;
	
	RcvTaskPointerLin = &GetCmdEchoByteLin;		// point to next state
}


void SendDataByteLin(void)
{
	switch(CmdPacketLin[1])
	{
		case 0: sdataALin = Gui_wSysMode;
				break;
		case 1: sdataALin = Gui_wLLCOutputVolt;
				break;
		default: 
				break;
	}
	PackTxBuffersLin();
	RcvTaskPointerLin = &GetCompleteByteLin;		// point to next state
}


void GetCompleteByteLin(void)
{
	UnpackRxBuffersLin();
	if(rdataALin == 0x00ff)
	{
		for (iLin=0; iLin<PktSizeLin; iLin++)
		{
			CmdPacketLin[iLin] = 0x0;
		}
		
		rdataALin = 0x0;
		sdataALin = 0x0;
	
		RcvTaskPointerLin = &GetCmdEchoByteLin;		// point to next state
	}
	
	else
		error();
}







//High priority LIN ISR.
interrupt void Lina_Level0_ISR(void)
{
	EALLOW;
	LinaRegs.SCIFLR.bit.IDLE == 1;
	EDIS;
	
	//Read-clear the interrupt vector
	LinL0IntVect = LinaRegs.SCIINTVECT0.all;
	
	wTestcnt++;
	wNoSciRevIntCnt = 0;

	//RXINT
	if(LinL0IntVect == 11)
	{		
		SerialHostCommsLin();
	}			
	
	//Other Interrupt
	else
	{
		//There should not be other interrupts
		error();
	}
	
	EALLOW;
	LinaRegs.SCIFLR.bit.IDLE == 0;
	EDIS;

	//Acknowledge the PIE to be able to receive more interrupts
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP9;
}



//Pack array words into LINTD buffer bytes
//sending high byte first.
void PackTxBuffersLin(void)
{
	LinaRegs.LINTD0.bit.TD0 = sdataALin >> 8;
	LinaRegs.LINTD0.bit.TD1 = sdataALin &  0x00FF;
	/*
	LinaRegs.LINTD0.bit.TD2 = sdataA[1] >> 8;
	LinaRegs.LINTD0.bit.TD3 = sdataA[1] &  0x00FF;
	LinaRegs.LINTD1.bit.TD4 = sdataA[2] >> 8;
	LinaRegs.LINTD1.bit.TD5 = sdataA[2] &  0x00FF;
	LinaRegs.LINTD1.bit.TD6 = sdataA[3] >> 8;
	LinaRegs.LINTD1.bit.TD7 = sdataA[3] &  0x00FF;
	*/
}

//Move data from LINRD buffers to data array.
void UnpackRxBuffersLin(void)
{
	Uint32 ReadData;
	ReadData = LinaRegs.LINRD0.all;
	rdataALin = (ReadData & 0xFFFF0000) >> 16;
	/*
	rdataA[1] = ReadData & 0x0000FFFF;
	ReadData = LinaRegs.LINRD1.all;
	rdataA[2] = (ReadData & 0xFFFF0000) >> 16;
	rdataA[3] = ReadData & 0x0000FFFF;
	*/
}

//Verify correct data transmission and
//increment test data.

void SetupLin(void)
{
	//Allow write to protected registers
	EALLOW;

	LinaRegs.SCIGCR0.bit.RESET = 0; //Into reset
	LinaRegs.SCIGCR0.bit.RESET = 1; //Out of reset

	LinaRegs.SCIGCR1.bit.SWnRST = 0; //Into software reset

	//SCI Configurations
	LinaRegs.SCIGCR1.bit.COMMMODE = 0;   //Idle-Line Mode
	LinaRegs.SCIGCR1.bit.TIMINGMODE = 1; //Asynchronous Timing
	LinaRegs.SCIGCR1.bit.PARITYENA = 0;  //No Parity Check
	LinaRegs.SCIGCR1.bit.PARITY = 0;	 //Odd Parity
	LinaRegs.SCIGCR1.bit.STOP = 0;		 //One Stop Bit
	LinaRegs.SCIGCR1.bit.CLK_MASTER = 1; //Enable SCI Clock
	LinaRegs.SCIGCR1.bit.LINMODE = 0;	 //SCI Mode
	LinaRegs.SCIGCR1.bit.SLEEP = 0;      //Ensure Out of Sleep
	LinaRegs.SCIGCR1.bit.MBUFMODE = 1;	 //Buffered Mode
	LinaRegs.SCIGCR1.bit.LOOPBACK = 0;   //External Loopback
	LinaRegs.SCIGCR1.bit.CONT = 1;		 //Continue on Suspend
	LinaRegs.SCIGCR1.bit.RXENA = 1;		 //Enable RX
	LinaRegs.SCIGCR1.bit.TXENA = 1;		 //Enable TX

	//Ensure IODFT is disabled
    LinaRegs.IODFTCTRL.bit.IODFTENA = 0x0;

    //Set transmission length
    LinaRegs.SCIFORMAT.bit.CHAR = 7;	 //Eight bits
    LinaRegs.SCIFORMAT.bit.LENGTH = 1;   //Two bytes

	//Set baudrate
    LinaRegs.BRSR.bit.SCI_LIN_PSL = 194;	 //9600bps for SYSCLKOUT = 60 MHz
    LinaRegs.BRSR.bit.M = 5;

	//Enable interrupts
	LinaRegs.SCISETINT.bit.SETRXINT = 1; //Enable RX interrupt

    //Set interrupt priority
	LinaRegs.SCICLEARINTLVL.all = 0xFFFFFFFF; //Set Int level of all interrupts to LVL 0

    LinaRegs.SCIGCR1.bit.SWnRST = 1;  //bring out of software reset

	//Disable write to protected registers
	EDIS;
}



void Inquiry_Panel_Voltage(void)
{
	CmdPacketLin[0] = 1;
	CmdPacketLin[1] = 0;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}

void Inquiry_Panel_Current(void)
{
	CmdPacketLin[0] = 1;
	CmdPacketLin[1] = 1;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}

void Inquiry_Boost_Voltage(void)
{
	CmdPacketLin[0] = 1;
	CmdPacketLin[1] = 2;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}

void Inquiry_Panel_Output_Power(void)
{
	CmdPacketLin[0] = 1;
	CmdPacketLin[1] = 3;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}

void Inquiry_MPPT_Status(void)
{
	CmdPacketLin[0] = 1;
	CmdPacketLin[1] = 4;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}

void Send_Running_Mode(void)
{
	CmdPacketLin[0] = 2;
	CmdPacketLin[1] = 0;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}

void Send_LLC_Output_Voltage(void)
{
	CmdPacketLin[0] = 2;
	CmdPacketLin[1] = 1;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}

void Send_Turn_On_Command(void)
{
	CmdPacketLin[0] = 3;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}

void Send_Turn_Off_Command(void)
{
	CmdPacketLin[0] = 4;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}

void Send_Turn_On_MPPT_Command(void)
{
	CmdPacketLin[0] = 5;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}

void Send_Turn_Off_MPPT_Command(void)
{
	CmdPacketLin[0] = 6;
	sdataALin = CmdPacketLin[0];
	PackTxBuffersLin();
}



void error(void)
{
	//asm("     ESTOP0"); // Test failed!! Stop!
	//for (;;);
	RcvTaskPointerLin = &GetCmdEchoByteLin;	 // Initialize the CmdPacket Rcv Handler state machine
}
