;---------------------------------------------------------------------------------
;	FILE:			PWMDRV_FBINV.asm
;
;	Description:	PWM driver for 3 phase rectifier
;
;	Version: 		2.0
;
;   Target:  		F2802x / F2803x
;--------------------------------------------------------------------------------
;  Copyright Texas Instruments  2010
;--------------------------------------------------------------------------------
;  Revision History:
;--------------------------------------------------------------------------------
;  Date	  	| Description
;--------------------------------------------------------------------------------
;  10/03/11	| Release 1.0  		New release.
;--------------------------------------------------------------------------------
;=============================
PWMDRV_FBINV_INIT	.macro	m,n
;=============================
; variable Declarations
_PWMDRV_Duty	  .usect "PWMDRV_FBINV_Section",2,1,1	; Input Terminal 1, Duty
_PWMDRV_Temp      .usect "PWMDRV_FBINV_Section",2,1,1
_PWMDRV_Ratio     .usect "PWMDRV_FBINV_Section",2,1,1
_PWMDRV_CMP_Max   .usect "PWMDRV_FBINV_Section",2,1,1
_PWMDRV_CMP_Min   .usect "PWMDRV_FBINV_Section",2,1,1


;Publish Terminal Pointers for access from the C environment
;===========================================================
		.def 	_PWMDRV_Duty 
		.def    _PWMDRV_Temp 
		.def 	_PWMDRV_Ratio 
		.def	_PWMDRV_CMP_Max 
		.def	_PWMDRV_CMP_Min 
	

		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_PWMDRV_Duty 
			MOVL	@_PWMDRV_Duty , XAR2
			
			MOVL    @_PWMDRV_Temp ,XAR2
			MOVL    @_PWMDRV_Ratio ,XAR2
			
			MOVW	DP,#_EPwm:n:Regs.TBPRD
			MOV		ACC,@_EPwm:n:Regs.TBPRD
			
			SUB     ACC,#1
			MOVW	DP, #_PWMDRV_CMP_Max
			MOVL    @_PWMDRV_CMP_Max ,ACC
			MOV     ACC,#0
			MOVL    @_PWMDRV_CMP_Min ,ACC
	
		.endm
;--------------------------------------------------------------------------------
; CMPA = (PWMDRV_Duty * PWMDRV_Ratio)
;======================
PWMDRV_FBINV		.macro m,n
;======================

			MOVW 	DP, #_PWMDRV_Duty 	        ; load DP for net pointer
       		MOVL   	XAR0, @_PWMDRV_Duty       	; Load net pointer address to XAR0 (Q10)
       		
       		MOVL    XAR1,@_PWMDRV_Temp 
       		MOVL    XAR2,@_PWMDRV_Ratio
       		
       		MOVL	XT, *XAR2					; Load net to XT
       		QMPYL  	ACC,XT,*XAR0    			; ACC= (Q24) * (Q8) = (Q32): upper 32-bits = (Q0)
			ABS     ACC
			MOVW    DP,#_PWMDRV_CMP_Max 
			MINL    ACC,@_PWMDRV_CMP_Max 
			MAXL    ACC,@_PWMDRV_CMP_Min 
			
			MOVL    *XAR1,ACC
			MOVL    ACC,*XAR0
			SUB     ACC,#0			
			B       _PWMDRV_1,LT
			;The duty > 0, then Q1,Q2 work in switch mode, 
			;Q3 is always off, Q4 is always on
			MOVL    ACC,*XAR1
       		MOVW    DP, #_EPwm:m:Regs.CMPA				
       		MOV     @_EPwm:m:Regs.CMPA.half.CMPA,AL	     ; CMPA = Duty * Period
			MOVW    DP,#_EPwm:n:Regs.CMPA
			MOV     @_EPwm:n:Regs.CMPA.half.CMPA,#0
			MOVW    DP, #0x1bf								;
			OR      @0x5, #0x0800							; use 2000 for gpio29
			B       _PWMDRV_2,UNC
_PWMDRV_1: 
 			;The duty < 0, then Q3,Q4 work in switch mode, 
			;Q1 is always off, Q2 is always on
			MOVL    ACC,*XAR1
 			MOVW    DP, #_EPwm:n:Regs.CMPA				
       		MOV     @_EPwm:n:Regs.CMPA.half.CMPA,AL	     ; CMPA = Duty * Period
			MOVW    DP,#_EPwm:m:Regs.CMPA
			MOV     @_EPwm:m:Regs.CMPA.half.CMPA,#0
			MOVW    DP, #0x1bf								;
			OR      @0x3, #0x0800							; use 2000 for gpio29
       		
_PWMDRV_2:
       		LSL     ACC,#9
			MOVL    *XAR1,ACC
			   	
		.endm


